package tonio.noa;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.view.MotionEvent;
import android.view.View;
import android.widget.TextView;

import java.util.Locale;

/**
 * Created by tonio on 23/11/17.
 */

public class BravoActivity extends Activity {

    private TextToSpeech bravoSpk;

    @Override
    protected void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        final Intent intent = getIntent();
        setContentView(R.layout.bravo_display);
        View view = findViewById(R.id.bravo_view);
        view.setOnTouchListener(new View.OnTouchListener() {

            @Override
            public boolean onTouch(View view, MotionEvent event) {
                setResult(RESULT_OK, intent);
                finish();
                return true;
            }
        });

        bravoSpk = new TextToSpeech(getApplicationContext(), new TextToSpeech.OnInitListener() {
            @Override
            public void onInit(int status) {
                if (status != TextToSpeech.ERROR) {
                    bravoSpk.setLanguage(Locale.FRENCH);
                    bravoSpk.speak(getString(R.string.bravotxt), TextToSpeech.QUEUE_FLUSH, null, null);
                }
            }
        });
    }

    @Override
    public void onDestroy() {
        if (bravoSpk != null) {
            bravoSpk.stop();
            bravoSpk.shutdown();
        }
        super.onDestroy();
    }
}
