package tonio.noa;

import android.content.ClipData;
import android.content.Intent;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.view.DragEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by psyk on 24/01/18.
 */

public class Hygiene4Activity extends MyPlayActivity implements View.OnTouchListener, View.OnDragListener {

    private int win_counter = 0;
    private boolean done = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        lanceConsigne("Tu peux m'aider ?\nPrépare mes affaires de toilette.");
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        setContentView(R.layout.hygiene4_display);

        TextView txtV = findViewById(R.id.cons_hyg4);
        smallCons = "Met les affaires de toilettes dans la trousse de toilette.";
        txtV.setText(smallCons);
        setTts();

        findViewById(R.id.snail).setOnTouchListener(this);
        findViewById(R.id.towel).setOnTouchListener(this);
        findViewById(R.id.elephant).setOnTouchListener(this);
        findViewById(R.id.bmw).setOnTouchListener(this);
        findViewById(R.id.toothpaste).setOnTouchListener(this);
        findViewById(R.id.blue_toothbrush_pic).setOnTouchListener(this);
        findViewById(R.id.trumpet).setOnTouchListener(this);
        findViewById(R.id.soap).setOnTouchListener(this);
        findViewById(R.id.shampoo).setOnTouchListener(this);

        findViewById(R.id.anchor_toilet_bag).setOnDragListener(this);
        findViewById(R.id.snail).setOnDragListener(this);
        findViewById(R.id.towel).setOnDragListener(this);
        findViewById(R.id.elephant).setOnDragListener(this);
        findViewById(R.id.bmw).setOnDragListener(this);
        findViewById(R.id.toothpaste).setOnDragListener(this);
        findViewById(R.id.blue_toothbrush_pic).setOnDragListener(this);
        findViewById(R.id.trumpet).setOnDragListener(this);
        findViewById(R.id.soap).setOnDragListener(this);
        findViewById(R.id.shampoo).setOnDragListener(this);
    }

    @Override
    public boolean onTouch(View view, MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {

            View.DragShadowBuilder shadowBuilder = new View.DragShadowBuilder(view);
            ClipData data = ClipData.newPlainText("id", view.getResources().getResourceEntryName(view.getId()));

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                view.startDragAndDrop(data, shadowBuilder, view, 0);
            } else {
                view.startDrag(data, shadowBuilder, view, 0);
            }
            return true;
        } else
            return false;
    }

    @Override
    public boolean onDrag(View v, DragEvent event) {
        switch (event.getAction()) {
            // signal for the start of a drag and drop operation
            case DragEvent.ACTION_DRAG_STARTED:
                // do nothing
                break;

            // the drag point has entered the bounding box of the View
            case DragEvent.ACTION_DRAG_ENTERED:
                // do nothing
                break;

            // the user has moved the drag shadow outside the bounding box of the View
            case DragEvent.ACTION_DRAG_EXITED:
                // do nothing
                break;

            // the drag and drop operation has concluded
            case DragEvent.ACTION_DRAG_ENDED:
                if (win_counter == 5 && !done) {
                    done = true;
                    bravoPage(v);
                }
                break;

            //drag shadow has been released,the drag point is within the bounding box of the View
            case DragEvent.ACTION_DROP:
                //handle the dragged view being dropped over a target view
                View view = (View) event.getLocalState();
                if (v == findViewById(R.id.anchor_toilet_bag)) {
                    if (view == findViewById(R.id.towel)
                            || view == findViewById(R.id.toothpaste)
                            || view == findViewById(R.id.blue_toothbrush_pic)
                            || view == findViewById(R.id.shampoo)
                            || view == findViewById(R.id.soap)) {
                        //stop displaying the view where it was before it was dragged
                        view.setVisibility(View.INVISIBLE);
                        win_counter++;
                    } else {
                        ImageView imageV = (ImageView) view;
                        imageV.setColorFilter(Color.GRAY);
                        view.setEnabled(false);
                    }
                }

                break;
        }
        return true;
    }


    @Override
    protected void next() {
        startActivity(new Intent(this, Hygiene5Activity.class));
    }
}
