package tonio.noa;

import android.content.ClipData;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.view.DragEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by psyk on 15/01/18.
 */

public class Hygiene6Activity extends MyPlayActivity implements View.OnTouchListener, View.OnDragListener {

    private int win_counter = 0;
    private boolean done = false;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        lanceConsigne("Cette fois, tu dois associer l'objet avec\nl'action qu'il permet de réaliser.");
    }

    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);

        setContentView(R.layout.hygiene6_display);

        TextView txtV = findViewById(R.id.cons_hyg6);
        smallCons = "Associe l'objet avec son action.";
        txtV.setText(smallCons);
        setTts();

        findViewById(R.id.marseille_soap).setOnTouchListener(this);
        findViewById(R.id.washing_hands).setOnTouchListener(this);
        findViewById(R.id.blue_toothbrush_pic).setOnTouchListener(this);
        findViewById(R.id.brushing_teeth).setOnTouchListener(this);

        findViewById(R.id.marseille_soap).setOnDragListener(this);
        findViewById(R.id.washing_hands).setOnDragListener(this);
        findViewById(R.id.brushing_teeth).setOnDragListener(this);
        findViewById(R.id.blue_toothbrush_pic).setOnDragListener(this);

    }

    @Override
    public boolean onTouch(View view, MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {

            View.DragShadowBuilder shadowBuilder = new View.DragShadowBuilder(view);
            ClipData data = ClipData.newPlainText("id", view.getResources().getResourceEntryName(view.getId()));

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                view.startDragAndDrop(data, shadowBuilder, view, 0);
            } else {
                view.startDrag(data, shadowBuilder, view, 0);
            }
            return true;
        } else
            return false;
    }

    @Override
    public boolean onDrag(View v, DragEvent event) {
        switch (event.getAction()) {
            // signal for the start of a drag and drop operation
            case DragEvent.ACTION_DRAG_STARTED:
                // do nothing
                break;

            // the drag point has entered the bounding box of the View
            case DragEvent.ACTION_DRAG_ENTERED:
                // do nothing
                break;

            // the user has moved the drag shadow outside the bounding box of the View
            case DragEvent.ACTION_DRAG_EXITED:
                // do nothing
                break;

            // the drag and drop operation has concluded
            case DragEvent.ACTION_DRAG_ENDED:
                if (win_counter == 2 && !done) {
                    done = true;
                    bravoPage(v);
                }
                break;

            //drag shadow has been released,the drag point is within the bounding box of the View
            case DragEvent.ACTION_DROP:
                //handle the dragged view being dropped over a target view
                View view = (View) event.getLocalState();
                if (
                        (v == findViewById(R.id.washing_hands) && view == findViewById(R.id.marseille_soap)) ||
                                (v == findViewById(R.id.marseille_soap) && view == findViewById(R.id.washing_hands)) ||
                                (v == findViewById(R.id.blue_toothbrush_pic) && view == findViewById(R.id.brushing_teeth)) ||
                                (v == findViewById(R.id.brushing_teeth) && view == findViewById(R.id.blue_toothbrush_pic))
                        ) {
                    //stop displaying the view where it was before it was dragged
                    view.setVisibility(View.INVISIBLE);
                    v.setVisibility(View.INVISIBLE);
                    win_counter++;
                }
                break;
        }

        return true;
    }

    @Override
    protected void next() {
        backHome(null);
    }
}
