package tonio.noa;

import android.content.ClipData;
import android.content.Intent;
import android.os.Build;
import android.os.Bundle;
import android.speech.tts.TextToSpeech;
import android.view.DragEvent;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Created by psyk on 09/01/18.
 */

public class TutorialScene2Activity extends MyPlayActivity implements View.OnTouchListener, View.OnDragListener {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        lanceConsigne("J'ai encore besoin de toi !\nMet le rectangle bleu sur le rouge.");
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        setContentView(R.layout.tutorial2_display);
        findViewById(R.id.blue_rectangle).setOnTouchListener(this);
        findViewById(R.id.blue_rectangle).setOnDragListener(this);
        findViewById(R.id.red_rectangle).setOnDragListener(this);
        TextView txtV = findViewById(R.id.cons_tut2);
        smallCons = "Fais glisser le rectangle bleu sur le rectangle rouge.";
        txtV.setText(smallCons);
        setTts();
    }


    @Override
    public boolean onTouch(View view, MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {

            View.DragShadowBuilder shadowBuilder = new View.DragShadowBuilder(view);
            ClipData data = ClipData.newPlainText("id", view.getResources().getResourceEntryName(view.getId()));

            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                view.startDragAndDrop(data, shadowBuilder, view, 0);
            } else {
                view.startDrag(data, shadowBuilder, view, 0);
            }
            return true;
        } else
            return false;
    }

    @Override
    public boolean onDrag(View v, DragEvent event) {
        switch (event.getAction()) {
            // signal for the start of a drag and drop operation
            case DragEvent.ACTION_DRAG_STARTED:
                // do nothing
                break;

            // the drag point has entered the bounding box of the View
            case DragEvent.ACTION_DRAG_ENTERED:
                // do nothing
                break;

            // the user has moved the drag shadow outside the bounding box of the View
            case DragEvent.ACTION_DRAG_EXITED:
                // do nothing
                break;

            // the drag and drop operation has concluded
            case DragEvent.ACTION_DRAG_ENDED:
                break;

            //drag shadow has been released,the drag point is within the bounding box of the View
            case DragEvent.ACTION_DROP:
                //handle the dragged view being dropped over a target view
                View view = (View) event.getLocalState();
                if (v == findViewById(R.id.red_rectangle)) {
                    //stop displaying the view where it was before it was dragged
                    view.setVisibility(View.INVISIBLE);
                    //view dragged item is being dropped on
                    ImageView dropTarget = (ImageView) v;
                    //view being dragged and dropped
                    ImageView dropped = (ImageView) view;
                    dropTarget.setBackgroundColor(dropped.getSolidColor());
                    bravoPage(v);
                }
                break;
        }

        return true;
    }

    @Override
    protected void next() {
        startActivity(new Intent(this, TutorialScene3Activity.class));
    }


}
